Attribute VB_Name = "Module1"
Option Explicit

'//Thanks Brykovian :-)

Private Const INV_SQR2 As Single = 2 ^ (-0.5)

Private Type udtPoint
    X As Single
    Y As Single
End Type

Function TriangleTLCircleCollision(tX As Single, tY As Single, tWidth As Single, cX As Single, cY As Single, cRadius As Single) As Long
    'There are only 8 points on the circle where we need to test for
    'collision with the exception of the corner collisions (which can
    'be tested by simple pythagorus)
    'This works by testing if any of these 8 points is inside the triangle
    'If any are then there is a collision.
    'Next, the distance from the centre of the circle to each of the verticies
    'of the triangle is checked.
    
    Dim CirclePoints(7) As udtPoint
    Dim TriangleVerticies(2) As udtPoint
    
    Dim PointX As Single
    Dim PointY As Single
    
    Dim Sgn1 As Long, Sgn2 As Long, Sgn3 As Long
    Dim i As Long
    
    'Gather information:
    
    'Triangle vertices:
    TriangleVerticies(0) = ReturnPoint(tX, tY)
    TriangleVerticies(1) = ReturnPoint(tX + tWidth, tY)
    TriangleVerticies(2) = ReturnPoint(tX, tY + tWidth)
    
    'Circle points
    CirclePoints(0) = ReturnPoint(cX, cY - cRadius)
    CirclePoints(1) = ReturnPoint(cX + cRadius * INV_SQR2, cY - cRadius * INV_SQR2)
    CirclePoints(2) = ReturnPoint(cX + cRadius, cY)
    CirclePoints(3) = ReturnPoint(cX + cRadius * INV_SQR2, cY + cRadius * INV_SQR2)
    CirclePoints(4) = ReturnPoint(cX, cY + cRadius)
    CirclePoints(5) = ReturnPoint(cX - cRadius * INV_SQR2, cY + cRadius * INV_SQR2)
    CirclePoints(6) = ReturnPoint(cX - cRadius, cY)
    CirclePoints(7) = ReturnPoint(cX - cRadius * INV_SQR2, cY - cRadius * INV_SQR2)
        
    'There are 3 lines making up the triangle. We will have 3 equations
    'which will tell us which side a point is on
    For i = 0 To 7
        'Left hand side: tX - PointX
        'Top side: tY - PointY
        'Diagonal: PointX + PointY - tX - tY - tWidth
        PointX = CirclePoints(i).X
        PointY = CirclePoints(i).Y
        
        Sgn1 = Sgn(tX - PointX)
        Sgn2 = Sgn(tY - PointY)
        Sgn3 = Sgn(PointX + PointY - tX - tY - tWidth)
        
        If Sgn1 = Sgn2 Then
            If Sgn2 = Sgn3 Then
                'Collision
                TriangleTLCircleCollision = -1
                Exit Function
            End If
        End If
    Next
    
    'Now test corner collisions
    For i = 0 To 2
        PointX = TriangleVerticies(i).X
        PointY = TriangleVerticies(i).Y
        
        If (PointX - cX) * (PointX - cX) + (PointY - cY) * (PointY - cY) < cRadius * cRadius Then
            'Collision
            TriangleTLCircleCollision = -1
            Exit Function
        End If
    Next
    
    'No collision if they make it this far
    TriangleTLCircleCollision = 0
End Function

Function TriangleTRCircleCollision(tX As Single, tY As Single, tWidth As Single, cX As Single, cY As Single, cRadius As Single) As Long
    'See TriangleTLCircleCollision for explanations
    Dim CirclePoints(7) As udtPoint
    Dim TriangleVerticies(2) As udtPoint
    Dim PointX As Single
    Dim PointY As Single
    Dim Sgn1 As Long, Sgn2 As Long, Sgn3 As Long
    Dim i As Long
    TriangleVerticies(0) = ReturnPoint(tX, tY)
    TriangleVerticies(1) = ReturnPoint(tX + tWidth, tY)
    TriangleVerticies(2) = ReturnPoint(tX + tWidth, tY + tWidth)
    CirclePoints(0) = ReturnPoint(cX, cY - cRadius)
    CirclePoints(1) = ReturnPoint(cX + cRadius * INV_SQR2, cY - cRadius * INV_SQR2)
    CirclePoints(2) = ReturnPoint(cX + cRadius, cY)
    CirclePoints(3) = ReturnPoint(cX + cRadius * INV_SQR2, cY + cRadius * INV_SQR2)
    CirclePoints(4) = ReturnPoint(cX, cY + cRadius)
    CirclePoints(5) = ReturnPoint(cX - cRadius * INV_SQR2, cY + cRadius * INV_SQR2)
    CirclePoints(6) = ReturnPoint(cX - cRadius, cY)
    CirclePoints(7) = ReturnPoint(cX - cRadius * INV_SQR2, cY - cRadius * INV_SQR2)
    For i = 0 To 7
        'Right hand side: PointX - (tX + tWidth)
        'Top side: tY - PointY
        'Diagonal: PointX - PointY - tX + tY
        PointX = CirclePoints(i).X
        PointY = CirclePoints(i).Y
        Sgn1 = Sgn(PointX - (tX + tWidth))
        Sgn2 = Sgn(tY - PointY)
        Sgn3 = -Sgn(PointX - PointY + tY - tX)
        If Sgn1 = Sgn2 Then
            If Sgn2 = Sgn3 Then
                TriangleTRCircleCollision = -1
                Exit Function
            End If
        End If
    Next
    For i = 0 To 2
        PointX = TriangleVerticies(i).X
        PointY = TriangleVerticies(i).Y
        If (PointX - cX) * (PointX - cX) + (PointY - cY) * (PointY - cY) < cRadius * cRadius Then
            TriangleTRCircleCollision = -1
            Exit Function
        End If
    Next
    TriangleTRCircleCollision = 0
End Function

Function TriangleBRCircleCollision(tX As Single, tY As Single, tWidth As Single, cX As Single, cY As Single, cRadius As Single) As Long
    'See TriangleTLCircleCollision for explanations
    Dim CirclePoints(7) As udtPoint
    Dim TriangleVerticies(2) As udtPoint
    Dim PointX As Single
    Dim PointY As Single
    Dim Sgn1 As Long, Sgn2 As Long, Sgn3 As Long
    Dim i As Long
    TriangleVerticies(0) = ReturnPoint(tX + tWidth, tY)
    TriangleVerticies(1) = ReturnPoint(tX + tWidth, tY + tWidth)
    TriangleVerticies(2) = ReturnPoint(tX, tY + tWidth)
    CirclePoints(0) = ReturnPoint(cX, cY - cRadius)
    CirclePoints(1) = ReturnPoint(cX + cRadius * INV_SQR2, cY - cRadius * INV_SQR2)
    CirclePoints(2) = ReturnPoint(cX + cRadius, cY)
    CirclePoints(3) = ReturnPoint(cX + cRadius * INV_SQR2, cY + cRadius * INV_SQR2)
    CirclePoints(4) = ReturnPoint(cX, cY + cRadius)
    CirclePoints(5) = ReturnPoint(cX - cRadius * INV_SQR2, cY + cRadius * INV_SQR2)
    CirclePoints(6) = ReturnPoint(cX - cRadius, cY)
    CirclePoints(7) = ReturnPoint(cX - cRadius * INV_SQR2, cY - cRadius * INV_SQR2)
    For i = 0 To 7
        'Right hand side: PointX - (tX + tWidth)
        'Bottom side: PointY - (tY + tWidth)
        'Diagonal: PointX + PointY - tX - tY - tWidth
        PointX = CirclePoints(i).X
        PointY = CirclePoints(i).Y
        Sgn1 = Sgn(PointX - (tX + tWidth))
        Sgn2 = Sgn(PointY - (tY + tWidth))
        Sgn3 = -Sgn(PointX + PointY - tX - tY - tWidth)
        If Sgn1 = Sgn2 Then
            If Sgn2 = Sgn3 Then
                TriangleBRCircleCollision = -1
                Exit Function
            End If
        End If
    Next
    For i = 0 To 2
        PointX = TriangleVerticies(i).X
        PointY = TriangleVerticies(i).Y
        If (PointX - cX) * (PointX - cX) + (PointY - cY) * (PointY - cY) < cRadius * cRadius Then
            TriangleBRCircleCollision = -1
            Exit Function
        End If
    Next
    TriangleBRCircleCollision = 0
End Function

Function TriangleBLCircleCollision(tX As Single, tY As Single, tWidth As Single, cX As Single, cY As Single, cRadius As Single) As Long
    'See TriangleTLCircleCollision for explanations
    Dim CirclePoints(7) As udtPoint
    Dim TriangleVerticies(2) As udtPoint
    Dim PointX As Single
    Dim PointY As Single
    Dim Sgn1 As Long, Sgn2 As Long, Sgn3 As Long
    Dim i As Long
    TriangleVerticies(0) = ReturnPoint(tX, tY)
    TriangleVerticies(1) = ReturnPoint(tX + tWidth, tY + tWidth)
    TriangleVerticies(2) = ReturnPoint(tX, tY + tWidth)
    CirclePoints(0) = ReturnPoint(cX, cY - cRadius)
    CirclePoints(1) = ReturnPoint(cX + cRadius * INV_SQR2, cY - cRadius * INV_SQR2)
    CirclePoints(2) = ReturnPoint(cX + cRadius, cY)
    CirclePoints(3) = ReturnPoint(cX + cRadius * INV_SQR2, cY + cRadius * INV_SQR2)
    CirclePoints(4) = ReturnPoint(cX, cY + cRadius)
    CirclePoints(5) = ReturnPoint(cX - cRadius * INV_SQR2, cY + cRadius * INV_SQR2)
    CirclePoints(6) = ReturnPoint(cX - cRadius, cY)
    CirclePoints(7) = ReturnPoint(cX - cRadius * INV_SQR2, cY - cRadius * INV_SQR2)
    For i = 0 To 7
        'Left hand side: tX - PointX
        'Bottom side: PointY - (tY + tWidth)
        'Diagonal: PointX - PointY - tX + tY
        PointX = CirclePoints(i).X
        PointY = CirclePoints(i).Y
        Sgn1 = Sgn(tX - PointX)
        Sgn2 = Sgn(PointY - (tY + tWidth))
        Sgn3 = Sgn(PointX - PointY - tX + tY)
        If Sgn1 = Sgn2 Then
            If Sgn2 = Sgn3 Then
                TriangleBLCircleCollision = -1
                Exit Function
            End If
        End If
    Next
    For i = 0 To 2
        PointX = TriangleVerticies(i).X
        PointY = TriangleVerticies(i).Y
        If (PointX - cX) * (PointX - cX) + (PointY - cY) * (PointY - cY) < cRadius * cRadius Then
            TriangleBLCircleCollision = -1
            Exit Function
        End If
    Next
    TriangleBLCircleCollision = 0
End Function


Private Function ReturnPoint(X As Single, Y As Single) As udtPoint
    ReturnPoint.X = X
    ReturnPoint.Y = Y
End Function


